			      /*  */
	       /* :  -  */
			  /* RED-BLACK TREES */
		     /*   ..:11/98 */


#include <stdio.h>
#include <conio.h>

static struct node{
    int  key,info,red;
  struct node *l,*r;
};
static struct node *head,*z,*gg,*g,*p,*x,*gc1;
int i1=0;
void plirofories();
void menu();
void rbtreeinitialize();
struct node *rotate(int,struct node *);
void split(int);
void rbtreeinsert(int);
void rbtreesearch(int);
void rbtreeprint(struct node *,int);
void rbtreeprint2(struct node *,int);
main()
{
int v,info,num,j;
char c;
clrscr();
plirofories();
gotoxy(22,24); printf("㩫 ⤘ 㡫  ⮜");
getch(); clrscr();

/* 高 夜 垩    ⤫. */

rbtreeinitialize();

/* ᤠ         暠
  ⨚      暨. */

menu();
c=getch();

/*  暨 坜    0.  夘 
   嫘 . */

 while (c!='0') {

/* 櫘 ⚮   */

   switch(c) {

/*  1: ᚜  桡-稦 ⤫  . */

     case '1': {clrscr();
	  printf("    驫         :");
		 scanf(" %d",&num);
		  for(j=1; j<=num; j++) {
	  printf("               驜 %2d ⨘  : ",j);
		     scanf(" %d",&v);
		     rbtreeinsert(v);

/* 夦    i1=0 ,  ᜠ    餦
  ⤜ ⮜   㩫 .  gc1 ⨤   
填  室      ⤫ ,櫠 夘 
  眠  㫞  ⤫    ᝜ . */

		     i1=0; gc1=head;
		     rbtreeprint2(head->r,0);
		   }
		gotoxy(1,24);
	     printf("\n                    㩫 ⤘ 㡫  ⮜");
		getch();
	      }
	  break;

/*  2: 㫞   ⩘  ⤫. */

     case '2': {clrscr();
		printf(" 驫  ⨘    㫞: ");
		 scanf(" %d",&v);
		 clrscr();

/*   gc1 ⨤    填  室    ⤫
  ᤜ  㫞 ⩘  ⤫ ៜ 橦 ᝜  . */

		 gc1=head->r; i1=0;
		 rbtreesearch(v);
		 getch();
	       }
	  break;

/*  3: ᤠ    ⤫. */

     case '3': {clrscr();
		 gotoxy(25,2); printf(" RED-BLACK TREE\n");
		 i1=0;  rbtreeprint(head->r,0);
		 gotoxy(1,24);
	     printf("\n                    㩫 ⤘ 㡫  ⮜");
		 getch();
		}
	  break;
    }
/*   椞  ᤠ      .*/

   clrscr(); menu();  c=getch();
  }
}

void plirofories()
{
gotoxy(20,2);
printf("桡-稘 ⤫ (Red-Black Trees) \n\n\n");
printf("         ⤫  夘  ⤞ 垩  2-3-4 ⤫ \n");
printf("\n    (. ⤫  ⮦ 1  2  3   2  3  4 棙 ) \n");
printf("\n     墦  椦    磙.   填 \n");
printf("\n       棙  ⤘  夘 稦,   填 \n");
printf("\n     餦      棙      夘 \n");
printf("\n    桡.   嫘 夘 櫠 梘  ᫠  \n");
printf("\n     碢 ⮦  因   ,  婞  夘 \n");
printf("\n      ᨮ   桡 填. \n");
}

/*  ᨫ  餜  椞    . */

void menu()
{
 gotoxy(23,5); printf(" 1.   R_B_Tree");
 gotoxy(23,7); printf(" 2. 㫞  R_B_Tree");
 gotoxy(23,9); printf(" 3. ᤠ  R_B_Tree");
 gotoxy(23,11); printf(" 0. 륦 ");
 gotoxy(31,14); printf(" : ");
}

/*  ᨫ  ᤜ  垩    夜 
    ⮦   秦 node . */

void rbtreeinitialize()
{

/*  ᨫ malloc 夘  㣞 ,. ᜠ 騦  㣞
ᢦ   ᚡ . ᜠ 騦 婦   ⚜   
⮦   . */

 z=(struct node *) malloc(sizeof *z);

/* 垩     z . */

 z->l=z; z->r=z; z->key=0; z->red=0;
 head=(struct node *) malloc(sizeof *head);

/* 垩    棞 head . */

 head->r=z; head->key=0; head->red=0;
}

/*  ᨫ  ⭜  填  妪  ✠   
 ⚠   ⤫ ,室   夞  
 ⚠   . */

struct node *rotate(int v,struct node *y)
{
 struct node *c,*gc;

/*   ⦪  ()  夘 櫜    
姜  ⤫  嫘  ᨫ ,櫜 嫜  填 c
   室 '   , 嫜  填 
 . */

 c=(v<y->key) ? y->l:y->r;

/*  騘   ()  夘 櫜     
填 c 櫜 , */

 if (v<c->key) {

/*   填 gc    室    填 c 
婡 '   .槠  填  室 '   c
娤    室       c ,. 
   ⦬ gc .맜 ᤜ  填 c  夘   
 gc . */

    gc=c->l; c->l=gc->r; gc->r=c; }
  else {

/*   填 gc    室     c .
ᤜ  填    c  ᨜    填  室
'      填 c .  ᤜ  填 c 
夘     gc . */

     gc=c->r; c->r=gc->l; gc->l=c; }

/*     夘 櫜     ⤘ 姜 
   姜  婡    室  填 gc ,櫜
嫜 '      填  室  gc
 嫜   . */

   if (v<y->key) y->l=gc;
    else y->r=gc;

return gc;
}

/*  ᨫ  ᤜ  ᩧ  ⤫  夘   
  㟜  ''rotate''  ⤦ ⤫   桡 
稦 填 . */

void split (int v)
{

/*  嫘   ᨫ  填   室  ᧦ 
 ⤫ 夜 棘 桡   夘 棜  填 
室 夞         ,夦 稦 .
 夜   夘      桡
填 . */

 x->red=1; x->l->red=0; x->r->red=0;

/*   填  室  ⨘    <> 夘 桡
櫜 ᤜ  ⨘    <p> 桡 . */

 if (p->red) {
    g->red=1;

/*  眠 ⩫  ⩞ ( v<g->key )    ⭜   㡞
夘 1 , 夘 0 , .      ⩜ 
眠   填 p    室   ᧦
    . */

    if (v<g->key != v<p->key)
      p=rotate(v,g);

/*   填     室  ᧦    ⤫
    韞    ⤫ . */

    x=rotate(v,gg);

/*  ᤜ  填   稦 . */

    x->red=0;
   }

/*  餜  ᩧ  ᨫ  ᤜ  填  
 ⤫ 稦 .  垩   key 娤 
 (0) ,梘    फ  ⤫ 婡  ⩞
櫜 . .    ⤫ 婡  ⩞ ''head->r'' 
夘   () , ''head->r->key'' . */

 head->r->red=0;
}

/* ᨫ       ⤫  RED_BLACK ⤦ */

void rbtreeinsert(int v)
{

/* 夜   x,g,p     ⩞ 㣞 
 婡    ⤫. */

  x=head; p=head; g=head;

/*    夘 ᭦  z .  ᩮ  ⤫  ⮜ ᩜ
 ⢦   ⮜  因   ⤫ ,⮠  ᩮ. */

   while (x!=z && v!=x->key) {

/*  填 p 嫜     ..  p ᜠ  ⤫ ⮨
   () 夦       ⦪  .
填 g ᜠ ៜ   ⨘  p .  填 gg ᜠ 
矬  ⛜   g .*/

      gg=g; g=p; p=x;

/*     室  填  夘 櫜   
 櫜 ⫞    填  室 '  
   室   .*/

      x=(v < x->key) ? x->l:x->r;

/*    () ᨮ 㛞 櫜  ᤜ    ⤫.*/

      if (v==x->key)
	    printf("                  驘 ᨮ 㛞.\n");
       else

/*   填  室    填 x 夘   
 桡  稦 櫜 ᤜ ᩧ    
 ⤫ .*/

	 if (x->l->red && x->r->red)
	  split(v);
    }

/*   ᩮ ⮜ ᩜ  ⢦    ⮜ ⟜   ⩘
 ⤫ 櫜 ᜠ   填   夘 秦  node ,騦 
㣞 婦   ⚜    ⮦    .*/

 if (x==z && v!=x->key) {
    x=(struct node *) malloc(sizeof *x);

/* ⫝̸      ⤫ ᤦ  填  
室   殨 㤜 騦  㣞   填 
夘       ,櫘  㩜 .*/

    x->key=v; x->l=z; x->r=z;

/*      夘 櫜   磜   ,
磜 '   填 p  填  ,  磜
   .*/

    if (v<p->key)  p->l=x;
      else p->r=x;

/*      '      填 p ,ᤜ
ᩧ  ⤫   夜 ⤦   ᤜ  填 
桡  稦 ᢦ   ⩞  ⩘  ⤫ .*/

   split(v);
 }
}

/* 㫞   ⩘  ⤫. */

void rbtreesearch(int v)
{ int level=1;         /*     姜  ⤫ */

struct node *gc,*gp; /* 填 , gp 室     */

/* 夦     <0>   婡  
  ᢠ(head) */

 gc=head->r;          /*    gc    ⤫ */

/*  櫘 ⚮ 嫘 橦  ⮜    棞 
  填  ⮜ ᩜ  ⢦  ⤫ */

 while (v!=gc->key && gc!=z) {

/*ᜠ  填 gp    gc ૦  ᥜ   室
 夘  磜   ⤫.   level ᤜ 
ៜ ⢜   室  棜 姜  ⤫. */

  gp=gc;  level++;
  i1=0;
  rbtreeprint2(head->r,0);

/*⚮  夘 櫜   㫞  夜 櫜
 ⤫  棜 姜  夜   */

   if (v<gc->key) {
      gotoxy(28,8);
      printf("  %d 夘 櫜   %d.\n",v,gc->key);
      gotoxy(28,9); printf("ꨘ  婡 '   ⤫. \n");
      gotoxy(28,10);printf("ᣜ  %d 姜  ⤫ ",level);

      gc=gc->l; /* 夜  填  矬  室   */

      gc1=gc;
     }
    else {
      gotoxy(28,8);
      printf("  %d 夘 竜   %d. \n",v,gc->key);
      gotoxy(28,9); printf("ꨘ  婡    ⤫. \n");
      gotoxy(28,10); printf("ᣜ  %d 姜  ⤫ ",level);

      gc=gc->r; /*   填  矬  室   */

      gc1=gc;
      }
    gotoxy(1,24);
    printf("\n                  㩫 ⤘ 㡫   棜 㣘 ");
     getch(); clrscr();

   } /* while */

/* ⚮   填 ⭫  ⢦  ⤫     
 夜   ᨮ  ⤫ */

 if (gc==z && v!=gc->key) {
     gotoxy(20,10); printf("    ⟞  ⤫.");
   }
   else {
     i1=0;
     rbtreeprint2(head->r,0);
     gotoxy(19,6);
     printf("   㫞 <%d> ⟞  ⤫  %do 姜."
       ,v,level);
     gotoxy(19,8);

/* ⚮    㫞 夘  殠    ⤫ */

     if (gc==head->r) printf("     ⤫, ᨘ  ⮜ .");
	else  printf("  ☪  夘  ... %d ",gp->key);
     gotoxy(19,10);

/* ⚮   填 夘 稦  桡 */

      if (gc->red==1)
	 printf("  填  室  %d 夘 桡.",gc->key);
      else  printf("  填  室  %d 夘 稦.",gc->key);
     gotoxy(19,12);
     printf(" To  %d ⮜       :",gc->key);
     gotoxy(22,15);
     printf(" : ");
	   if (gc->l->key!=0)          /*⚮  ᨮ  */
		  printf("%d",gc->l->key);
	      else   printf("--");
     gotoxy(47,15);
     printf(" : ");
	   if (gc->r->key!=0)          /* ⚮  ᨮ   */
		  printf("%d",gc->r->key);
	      else   printf("--");

   } /* else */
}

/* ᨫ    ᤠ  桡-稦 ⤫ */

void rbtreeprint(struct node *x,int level)
{ int i;

/* ⚮   填  室  ⢦  ⤫ */

  if (x!=z) {

/* ⚮     坜 夘    ⤫ */

    if (x->key==head->r->key) printf(" \n");

/* 㤜   餜   ᤠ ᢦ   姜 
  婡  ⤫ */

    for(i=1; i<=level; i++) printf("%2c",179);

/* 餜    ⤫ ᢦ   姜   婡 */

    printf("%2d",x->key);
     for(i=1; i<=(18-2*level); i++) printf(" ");

/* ⚮    ⮜    殠 */

	 if (x->l->key==0)
	       printf("A < >");
	  else {

/* ⚮   填  室    夘 桡 
稦 */

	     if (x->l->red==1)
	       printf("=%d<填 桡>",x->l->key);
	       else
	       printf("=%d<填 稦>",x->l->key);
	   }

/* ⚮    ⮜ ⥠   殠 */

	 if (x->r->key==0)
	      printf("--< >\n");
	  else {

/* ⚮   填  室    夘 桡  稦*/

	   if (x->r->red==1)
	       printf("--=%d<填 桡>\n",x->r->key);
	    else printf("--=%d<填 稦>\n",x->r->key);
	   }
	 i1++;

/*   22  ⤜  
    㩫   婜. */

       if (i1%22==0) {
	  i1=0;  getch();
	 }
    rbtreeprint(x->l,level+1);
    rbtreeprint(x->r,level+1);
  }
}

/* ᨫ  槦 坜  ⤫  㫞 
      㫞  棘 ⩘  ⤫. */

void rbtreeprint2(struct node *x,int level)
{
int i;

/* 뢜   ⢦  ⤫. */

  if (x!=z) {
     if (x->key==head->r->key) printf("\n");
     i1++;

/* 㤜   坜     室  姜  ៜ
 妬  ⤫. */

    for(i=1; i<=level; i++)
      printf("%2c",179);
     printf("%2d",x->key);

/* ⚮   22   椞 ⤜   ᧦
  㡫   婜. */

    if (i1%22==0) {
	 i1=0; getch();
       }
/* 室  ⤫     婡  㫞. */

     if (x->key==gc1->key) printf(" %c%c\n",17,16);
       else printf("\n");

/*   ᨫ. */

   rbtreeprint2(x->l,level+1);
   rbtreeprint2(x->r,level+1);
 }
}