			      /*  */
	       /* :  -  */
			  /* RED-BLACK TREES */
		     /*   ..:11/98 */


#include <stdio.h>
#include <conio.h>

static struct node{
    int  key,info,red;
  struct node *l,*r;
};
static struct node *head,*z,*gg,*g,*p,*x,*gc1;
int i1=0;
void plirofories();
void menu();
void rbtreeinitialize();
struct node *rotate(int,struct node *);
void split(int);
void rbtreeinsert(int);
void rbtreesearch(int);
void rbtreeprint(struct node *,int);
void rbtreeprint2(struct node *,int);
main()
{
int v,info,num,j;
char c;
clrscr();
plirofories();
gotoxy(22,24); printf("㩫 ⤘ 㡫  ⮜");
getch(); clrscr();
rbtreeinitialize();
menu();
c=getch();
while (c!='0') {
   switch(c) {
     case '1': {clrscr();
	  printf("    驫         :");
		 scanf(" %d",&num);
		  for(j=1; j<=num; j++) {
	  printf("               驜 %2d ⨘  : ",j);
		     scanf(" %d",&v);
		     rbtreeinsert(v);
		     i1=0; gc1=head;
		     rbtreeprint2(head->r,0);
		   }
		gotoxy(1,24);
	     printf("\n                    㩫 ⤘ 㡫  ⮜");
		getch();
	      }
	  break;
     case '2': {clrscr();
		printf(" 驫  ⨘    㫞: ");
		 scanf(" %d",&v);
		 clrscr();
		 gc1=head->r; i1=0;
		 rbtreesearch(v);
		 getch();
	       }
	  break;
     case '3': {clrscr();
		 gotoxy(25,2); printf(" RED-BLACK TREE\n");
		 i1=0;  rbtreeprint(head->r,0);
		 gotoxy(1,24);
	     printf("\n                    㩫 ⤘ 㡫  ⮜");
		 getch();
		}
	  break;
    }
   clrscr(); menu();  c=getch();
  }
}

void plirofories()
{
gotoxy(20,2);
printf("桡-稘 ⤫ (Red-Black Trees) \n\n\n");
printf("         ⤫  夘  ⤞ 垩  2-3-4 ⤫\n");
printf("\n     (. ⤫  ⮦ 1  2  3   2  3  4 棙 )\n");
printf("\n      墦  椦    磙.   填\n");
printf("\n        棙  ⤘  夘 稦,   填\n");
printf("\n      餦      棙      夘\n");
printf("\n     桡.   嫘 夘 櫠 梘  ᫠ \n");
printf("\n      碢 ⮦  因   ,  婞  夘\n");
printf("\n       ᨮ   桡 填.\n");
}

void menu()
{
 gotoxy(23,5); printf(" 1.   R_B_Tree");
 gotoxy(23,7); printf(" 2. 㫞  R_B_Tree");
 gotoxy(23,9); printf(" 3. ᤠ  R_B_Tree");
 gotoxy(23,11); printf(" 0. 륦 ");
 gotoxy(31,14); printf(" : ");
}


void rbtreeinitialize()
{
 z=(struct node *) malloc(sizeof *z);
 z->l=z; z->r=z; z->key=0; z->red=0;
 head=(struct node *) malloc(sizeof *head);
 head->r=z; head->key=0; head->red=0;
}

struct node *rotate(int v,struct node *y)
{
 struct node *c,*gc;
 c=(v<y->key) ? y->l:y->r;
 if (v<c->key) {
    gc=c->l; c->l=gc->r; gc->r=c; }
  else {
     gc=c->r; c->r=gc->l; gc->l=c; }
   if (v<y->key) y->l=gc;
    else y->r=gc;

return gc;
}

void split (int v)
{
 x->red=1; x->l->red=0; x->r->red=0;
 if (p->red) {
    g->red=1;
    if (v<g->key != v<p->key)
      p=rotate(v,g);
    x=rotate(v,gg);
    x->red=0;
   }
 head->r->red=0;
}

void rbtreeinsert(int v)
{
  x=head; p=head; g=head;
   while (x!=z && v!=x->key) {
      gg=g; g=p; p=x;
      x=(v < x->key) ? x->l:x->r;
      if (v==x->key)
	    printf("                  驘 ᨮ 㛞.\n");
       else
	 if (x->l->red && x->r->red)
	  split(v);
    }
 if (x==z && v!=x->key) {
    x=(struct node *) malloc(sizeof *x);
    x->key=v; x->l=z; x->r=z;
    if (v<p->key)  p->l=x;
      else p->r=x;
   split(v);
 }
}

void rbtreesearch(int v)
{
int level=1;
struct node *gc,*gp; 
 gc=head->r;         
 while (v!=gc->key && gc!=z) {
  gp=gc;  level++;
  i1=0;
  rbtreeprint2(head->r,0);
   if (v<gc->key) {
      gotoxy(28,8);
      printf("  %d 夘 櫜   %d.\n",v,gc->key);
      gotoxy(28,9); printf("ꨘ  婡 '   ⤫. \n");
      gotoxy(28,10);printf("ᣜ  %d 姜  ⤫ ",level);

      gc=gc->l;
      gc1=gc;
     }
    else {
      gotoxy(28,8);
      printf("  %d 夘 竜   %d. \n",v,gc->key);
      gotoxy(28,9); printf("ꨘ  婡    ⤫. \n");
      gotoxy(28,10); printf("ᣜ  %d 姜  ⤫ ",level);

      gc=gc->r; 
      gc1=gc;
      }
    gotoxy(1,24);
    printf("\n                  㩫 ⤘ 㡫   棜 㣘 ");
     getch(); clrscr();

   } /* while */
 if (gc==z && v!=gc->key) {
     gotoxy(20,10); printf("    ⟞  ⤫.");
   }
   else {
     i1=0;
     rbtreeprint2(head->r,0);
     gotoxy(19,6);
     printf("   㫞 <%d> ⟞  ⤫  %do 姜."
       ,v,level);
     gotoxy(19,8);
     if (gc==head->r) printf("     ⤫, ᨘ  ⮜ .");
	else  printf("  ☪  夘  ... %d ",gp->key);
     gotoxy(19,10);
      if (gc->red==1)
	 printf("  填  室  %d 夘 桡.",gc->key);
      else  printf("  填  室  %d 夘 稦.",gc->key);
     gotoxy(19,12);
     printf(" To  %d ⮜       :",gc->key);
     gotoxy(22,15);
     printf(" : ");
           if (gc->l->key!=0)          
		  printf("%d",gc->l->key);
	      else   printf("--");
     gotoxy(47,15);
     printf(" : ");
           if (gc->r->key!=0)          
		  printf("%d",gc->r->key);
	      else   printf("--");

   } /* else */
}

void rbtreeprint(struct node *x,int level)
{ int i;
  if (x!=z) {
    if (x->key==head->r->key) printf(" \n");
    for(i=1; i<=level; i++) printf("%2c",179);
    printf("%2d",x->key);
     for(i=1; i<=(18-2*level); i++) printf(" ");
	 if (x->l->key==0)
	       printf("A < >");
	  else {
	     if (x->l->red==1)
	       printf("=%d<填 桡>",x->l->key);
	       else
	       printf("=%d<填 稦>",x->l->key);
	   }
	 if (x->r->key==0)
	      printf("--< >\n");
	  else {
	   if (x->r->red==1)
	       printf("--=%d<填 桡>\n",x->r->key);
	    else printf("--=%d<填 稦>\n",x->r->key);
	   }
	 i1++;
       if (i1%22==0) {
	  i1=0;  getch();
	 }
    rbtreeprint(x->l,level+1);
    rbtreeprint(x->r,level+1);
  }
}

void rbtreeprint2(struct node *x,int level)
{
int i;
  if (x!=z) {
     if (x->key==head->r->key) printf("\n");
     i1++;
    for(i=1; i<=level; i++)
      printf("%2c",179);
     printf("%2d",x->key);
    if (i1%22==0) {
	 i1=0; getch();
       }
     if (x->key==gc1->key) printf(" %c%c\n",17,16);
       else printf("\n");
   rbtreeprint2(x->l,level+1);
   rbtreeprint2(x->r,level+1);
 }
}
